package com.yeejoin.amos.boot.module.hygf.api.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.yeejoin.amos.boot.biz.common.entity.BaseEntity;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;
import java.util.List;

/**
 * 第三方场站
 *
 * @author system_generator
 * @date 2023-09-19
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("hygf_jp_station")
public class JpStation extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * sn编码
     */
	@TableField("sn_code")
    private String snCode;

    /**
     * 装机容量
     */
	@TableField("capacity")
    private Double capacity;

    /**
     * 电站名称
     */
	@TableField("name")
    private String name;

    /**
     * 电站编码
     */
	@TableField("code")
    private String code;

    /**
     * 组织编码
     */
	@TableField("system_code")
    private String systemCode;

    /**
     * 接入平台时间
     */
	@TableField("access_time")
    private Date accessTime;

    /**
     * 创建时间
     */
	@TableField("create_time")
    private Date createTime;

    /**
     * 地址
     */
	@TableField("address")
    private String address;

    /**
     * 经度
     */
	@TableField("longitude")
    private String longitude;

    /**
     * 维度
     */
	@TableField("latitude")
    private String latitude;

    /**
     * 上网电价
     */
	@TableField("price")
    private Double price;

    /**
     * 业主姓名
     */
	@TableField("user_name")
    private String userName;

    /**
     * 业主电话
     */
	@TableField("user_phone")
    private String userPhone;

    /**
     * 电站联系人
     */
	@TableField("station_contact")
    private String stationContact;

    /**
     * 组件数量
     */
	@TableField("module_count")
    private Integer moduleCount;

    /**
     * 并网类型
     */
	@TableField("on_grid_type")
    private String onGridType;

    /**
     * 并网时间
     */
	@TableField("on_grid_time")
    private Date onGridTime;

    /**
     * 第三方电站id
     */
	@TableField("third_station_id")
    private String thirdStationId;

    /**
     * 电站id
     */
	@TableField("station_id")
    private Long stationId;

    /**
     * 第三方厂商标识
     */
	@TableField("third_code")
    private String thirdCode;

    /**
     * 实时功率
     */
    @TableField("real_time_power")
    private Double	realTimePower;
    /**
     * 累计发电量
     */
    @TableField("accumulated_power")
    private Double	accumulatedPower;
    /**
     * 状态
     */
    @TableField("state")
    private String state;
    /**
     * 电站类型
     */
    @TableField("type")
    private String type	;
    /**
     *  组织编码
     */
    @TableField("organizational_code")
    private String organizationalCode;
    //日发电量
    @TableField("day_generate")
    private Double dayGenerate;
    //月发电量
    @TableField("month_generate")
    private Double monthGenerate;
   //年发电量
    @TableField("year_generate")
    private Double yearGenerate;
    //日收益
    @TableField("day_income")
    private Double  dayIncome;
   //月收益
    @TableField("month_income")
    private Double monthIncome;
    // 年收益
    @TableField("year_income")
    private Double yearIncome;
    //地区
    @TableField("area")
    private String area;
    //累计收益
    @TableField("cumulative_income")
    private Double cumulativeIncome;


    @TableField("day_power_use")
    private Double dayPowerUse;	//	日用电量
    @TableField("month_power_use")
    private Double monthPowerPse;	//	月用电量
    @TableField("year_power_use")
    private Double yearPowerUse;	//	年用电量


    @TableField("email")
    private String email; //邮箱

    @TableField("rated_power")
    private Double ratedPower;


    /**
     * 所属区域公司code
     */
    @TableField("regional_companies_code")
    private String regionalCompaniesCode;

    @TableField("amos_company_code")
    private String amosCompanyCode;

    @TableField(exist = false)
    private List<String> snCodes;

}
