package com.yeejoin.amos.boot.module.jxiop.api.dto;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.yeejoin.amos.boot.biz.common.excel.CommonExplicitConstraint;
import com.yeejoin.amos.boot.biz.common.excel.ExplicitConstraint;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
/**
 * @description:
 * @author: tw
 * @createDate: 2023/4/24
 */

@Data
@ApiModel(value = "ExStationBasicDto", description = "")
public class ExStationBasicDto {
    @ExcelProperty(value = "场站名称", index = 0)
    @ApiModelProperty(value = "场站名称")
    private String stationName;
    @ExcelProperty(value = "场站编号", index = 1)
    @ApiModelProperty(value = "场站编号")
    private String stationCode;
    @ExplicitConstraint(indexNum = 2, source = {"开发","策划","在建","停建","完工","结算","尾款","关闭","终止","运维","测试"}) //固定下拉内容
    @ExcelProperty(value = "项目状态", index = 2)
    @ApiModelProperty(value = "项目状态")
    private String stationFlag;
    @ExplicitConstraint(indexNum = 3, sourceClass = CommonExplicitConstraint.class, method = "getstationType") //固定下拉内容
    @ExcelProperty(value = "场站类型", index = 3)
    @ApiModelProperty(value = "场站类型")
    private String stationType;
    @ExcelProperty(value = "站长", index = 4)
    @ApiModelProperty(value = "站长")
    private String stationMasterName;
    @ExcelProperty(value = "手机号码", index = 5)
    @ApiModelProperty(value = "手机号码")
    private String mobilePhone;
    @ExcelProperty(value = "邮箱", index = 6)
    @ApiModelProperty(value = "邮箱")
    private String email;
    @ExcelProperty(value = "运维时间", index = 7)
    @ApiModelProperty(value = "运维时间")
    @DateTimeFormat("yyyy-MM-dd")
    @JsonFormat(pattern="yyyy-MM-dd")
    private String devopsTime;
    @ExcelProperty(value = "运维单位", index = 8)
    @ApiModelProperty(value = "运维单位")
    private String ownerUnit;
    @ExcelProperty(value = "场站地址", index = 9)
    @ApiModelProperty("场站地址")
    private String address;
    @ExplicitConstraint(indexNum = 10, sourceClass = CommonExplicitConstraint.class, method = "getArea") //固定下拉内容
    @ExcelProperty(value = "所属片区", index = 10)
    @ApiModelProperty(value = "所属片区")
    private String area;
    @ExcelProperty(value = "场站简介", index = 11)
    @ApiModelProperty(value = "场站简介")
    private String briefIntroduction;

}
