package com.yeejoin.amos.boot.module.jxiop.biz.controller;

import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import java.util.List;
import com.yeejoin.amos.boot.module.jxiop.biz.service.impl.PersonSkillEducationServiceImpl;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.jxiop.api.dto.PersonSkillEducationDto;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 人员技能和学历
 *
 * @author system_generator
 * @date 2023-04-20
 */
@RestController
@Api(tags = "人员技能和学历Api")
@RequestMapping(value = "/person-skill-education")
public class PersonSkillEducationController extends BaseController {

    @Autowired
    PersonSkillEducationServiceImpl personSkillEducationServiceImpl;

    /**
     * 新增人员技能和学历
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增人员技能和学历", notes = "新增人员技能和学历")
	public ResponseModel<PersonSkillEducationDto> save(@RequestBody PersonSkillEducationDto model) {
	    model = personSkillEducationServiceImpl.createWithModel(model);
	    return ResponseHelper.buildResponse(model);
	}

	/**
     * 根据sequenceNbr更新
     *
     * @param sequenceNbr 主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "根据sequenceNbr更新人员技能和学历", notes = "根据sequenceNbr更新人员技能和学历")
	public ResponseModel<PersonSkillEducationDto> updateBySequenceNbrPersonSkillEducation(@RequestBody PersonSkillEducationDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr) {
	    model.setSequenceNbr(sequenceNbr);
	    return ResponseHelper.buildResponse(personSkillEducationServiceImpl.updateWithModel(model));
	}

	/**
     * 根据sequenceNbr删除
     *
     * @param sequenceNbr 主键
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @DeleteMapping(value = "/{sequenceNbr}")
    @ApiOperation(httpMethod = "DELETE", value = "根据sequenceNbr删除人员技能和学历", notes = "根据sequenceNbr删除人员技能和学历")
    public ResponseModel<Boolean> deleteBySequenceNbr(HttpServletRequest request, @PathVariable(value = "sequenceNbr") Long sequenceNbr){
        return ResponseHelper.buildResponse(personSkillEducationServiceImpl.removeById(sequenceNbr));
    }

    /**
     * 根据sequenceNbr查询
     *
	 * @param sequenceNbr  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "GET",value = "根据sequenceNbr查询单个人员技能和学历",  notes = "根据sequenceNbr查询单个人员技能和学历")
	public ResponseModel<PersonSkillEducationDto> selectOne(@PathVariable Long sequenceNbr) {
	    return ResponseHelper.buildResponse(personSkillEducationServiceImpl.queryBySeq(sequenceNbr));
	}

	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "人员技能和学历分页查询",  notes = "人员技能和学历分页查询")
	public ResponseModel<Page<PersonSkillEducationDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<PersonSkillEducationDto> page = new Page<PersonSkillEducationDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(personSkillEducationServiceImpl.queryForPersonSkillEducationPage(page));
	}

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "人员技能和学历列表全部数据查询",   notes = "人员技能和学历列表全部数据查询")
	@GetMapping(value = "/list")
	public ResponseModel<List<PersonSkillEducationDto>> selectForList() {
	    return ResponseHelper.buildResponse(personSkillEducationServiceImpl.queryForPersonSkillEducationList());
	}
}
